/*  This file is part of FediBlock-backend.
 *  Copyright © 2020 tastytea <tastytea@tastytea.de>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, version 3.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef FEDIBLOCK_BACKEND_FILES_HPP
#define FEDIBLOCK_BACKEND_FILES_HPP

#include "fs-compat.hpp"

#include <string>

namespace FediBlock::files
{

using std::string;

// Creates and returns the temporary directory.
[[nodiscard]] fs::path get_tmpdir();

// Remove the temporary directory. Throws runtime_error on error.
void remove_tmpdir();

// Returns the data directory and creates it if necessary.
[[nodiscard]] fs::path get_datadir();

// Read and return access token.
[[nodiscard]] string get_access_token();

} // namespace FediBlock::files

#endif // FEDIBLOCK_BACKEND_FILES_HPP
