/*  This file is part of FediBlock-backend.
 *  Copyright © 2020 tastytea <tastytea@tastytea.de>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, version 3.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "json.hpp"
#include "fs-compat.hpp"

#include <nlohmann/json.hpp>

namespace FediBlock::json
{

string to_json(const cgi::entry_type &entry)
{
    const string filename{fs::path(entry.screenshot_filepath).filename()};
    const nlohmann::json json{{"instance", entry.instance},
                              {"tags", entry.tags},
                              {"receipts", entry.receipts},
                              {"description", entry.description},
                              {"screenshot", filename}};
    return json.dump(4);
}

string pull_request_body(string_view branch, const cgi::entry_type &entry)
{
    const nlohmann::json json{{"base", "main"},
                              {"head", branch},
                              {"title", "From web: " + entry.instance},
                              {"body", entry.description}};
    return json.dump();
}

} // namespace FediBlock::json
