/*  This file is part of FediBlock-backend.
 *  Copyright © 2020 tastytea <tastytea@tastytea.de>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, version 3.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef FEDIBLOCK_BACKEND_JSON_HPP
#define FEDIBLOCK_BACKEND_JSON_HPP

#include "cgi.hpp"

#include <string>
#include <string_view>

namespace FediBlock::json
{

using std::string;
using std::string_view;

// Convert an entry_type into a JSON string.
[[nodiscard]] string to_json(const cgi::entry_type &entry);

[[nodiscard]] string pull_request_body(string_view branch,
                                       const cgi::entry_type &entry);

} // namespace FediBlock::json

#endif // FEDIBLOCK_BACKEND_JSON_HPP
